{******************************************}
{                                          }
{           vtk GridReport library         }
{                                          }
{      Copyright (c) 2003 by vtkTools      }
{                                          }
{******************************************}
{Registers the components and determine where to install them on the Component palette}
unit vgr_ControlsReg;

{$I vtk.inc}

interface

uses
  Classes,

  vgr_ColorButton, vgr_FontComboBox,
  vgr_ControlBar, vgr_Label;

procedure Register;

implementation

{$R *.res}

procedure Register;
begin
  RegisterComponents('vtk Controls', [TvgrColorButton,
                                      TvgrFontComboBox,
                                      TvgrControlBar,
                                      TvgrControlBarManager,
                                      TvgrBevelLabel]);
end;

end.
