(*
   Firebird Library
   File:FBLReg.pas
   Copyright (c) 2002 Alessandro Batisti
   abatisti@tiscali.it
   http://web.tiscali.it/fblib

  * This file is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
  * This file is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
*)


unit FBLReg;
{$R fblpalette.res}

interface

uses
  Classes,
  FBLDatabase,
  FBLTransaction,
  FBLDsql,
  FBLMetadata,
  FBLScript;

const
  PALETTE_NAME = 'FBLib';

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents(PALETTE_NAME, [TFBLDatabase, TFBLTransaction,
    TFBLDsql, TFBLMetadata, TFBLSCript]);
end;


end.
