unit SCORunner;

interface
 {$WARNings OFF}
uses
  SysUtils, Classes, IdBaseComponent, IdCustomHttpServer, ConsoleOutput, Forms, Filectrl,Registry, windowS, idtcpserver;

type
  TidSCORunner = class(TIdBaseComponent)
  private
    Output: TStringList;
    procedure RunningUpdate(Process: THandle; const NewLine: String);
    function GetWinDir: string;
  protected
    { Protected declarations }
  public
    Procedure Execute(ATheard: TIdPeerThread; RequestInfo: TIdHTTPRequestInfo; ResponseInfo: TIdHTTPResponseInfo; ExeName: string; Server: TIdCustomHTTPServer; SCOContentType: string);
    function GetText(FName: string; Params: TStrings): string;
  published

  end;

procedure Register;

implementation
var
reg: TRegistry;

procedure Register;
begin
  RegisterComponents('Indy Misc', [TidSCORunner]);
end;

{ TSCORunner }

procedure TidSCORunner.Execute(ATheard: TIdPeerThread; RequestInfo: TIdHTTPRequestInfo;
  ResponseInfo: TIdHTTPResponseInfo; ExeName: string; Server: TIdCustomHTTPServer; SCOContentType: string);

begin
Output:=TStringList.Create;
ExecConsoleApp(ExeName, RequestInfo.Params.Text, Output, RunningUpdate);
ForceDirectories(GetWinDir+'\temp\');
ResponseInfo.ContentType:=SCOContentType;
output.SaveToFile(GetWinDir+'\temp\'+'temp.htm');
server.ServeFile(ATheard,ResponseInfo,GetWinDir+'\temp\'+'temp.htm');
Output.Free;
end;

function TidSCORunner.GetText(FName: string; Params: TStrings): string;
begin
//Result has got key return in chars #13#10!!!
Output:=TStringList.Create;
ExecConsoleApp(FName, Params.Text, Output, RunningUpdate);
Result:=Output.Text;
Output.Free;
end;

function TidSCORunner.GetWinDir: string;
begin
 Reg := TRegistry.Create;
 Reg.RootKey := HKEY_LOCAL_MACHINE;
 Reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Setup', False);
 GetWinDir := Reg.ReadString('WinDir');
 Reg.Free;
end;

procedure TidScorunner.RunningUpdate(Process: THandle; const NewLine: String);
begin
Application.ProcessMessages;
   {flush paint messages to show progress}
//    TerminateProcess(Process, 101)
end;



end.
