unit ucrearegkey;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Button1: TButton;
    Edit3: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    edit4: TEdit;
    Image1: TImage;
    Label5: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    fcodeKey: string;
    function Code(Text: string): shortstring;
    function Decode(CodedText: string): shortstring;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function TForm1.Code(Text: string): shortstring;
var
  DataSize, i, q, k: short;
begin
  Result:= '';
  DataSize:= Length(Text);
  k:= 1;
  for i:= 1 to DataSize do
  begin
    q:= Ord(Text[i]) xor Ord(fcodeKey[k]);
    Inc(k);
    if k > Length(fcodeKey) then
      k:= 1;
    Result:= Result + IntToHex(q, 2);
  end;
end;

function TForm1.Decode(CodedText: string): shortstring;
var
  DataSize, q, Q1, k, Len: short;
  P: PChar;

  function HexaToInt(ch: char): short;
  begin
    case ch of
      '0'..'9': Result:= StrToInt(ch);
      'A': Result:= 10;
      'B': Result:= 11;
      'C': Result:= 12;
      'D': Result:= 13;
      'E': Result:= 14;
      'F': Result:= 15;
    else
      Result:= 7;
    end;
  end;

begin
  Result:= '';
  k:= 1;
  P:= PChar(CodedText);
  DataSize:= Length(CodedText);
  Len:= Length(fcodeKey);
  if Len > DataSize then
    Len:= DataSize;
  while DataSize > 0 do
  begin
    case P^ of
      #10, #13, #32: Inc(P);
    else
      Q1:= HexaToInt(P^);
      Inc(P);
      q:= HexaToInt(P^);
      Inc(P);
      q:= (Q1 * 16) + q;
      q:= q xor (Ord(fcodeKey[k]));
      Inc(k);
      if k > Len then
        k:= 1;
      Result:= Result + chr(q);
    end;
    Dec(DataSize, 2);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  fcodeKey:= edit4.Text;
  Edit3.Text:= Code(Edit2.Text + Decode(Edit1.Text));
end;

end.

