object MainForm: TMainForm
  Left = 208
  Top = 107
  BorderIcons = [biSystemMenu, biMinimize]
  BorderStyle = bsSingle
  Caption = 'Raw Drive Access'
  ClientHeight = 409
  ClientWidth = 638
  Color = clBtnFace
  Font.Charset = ANSI_CHARSET
  Font.Color = clWindowText
  Font.Height = -12
  Font.Name = 'Tahoma'
  Font.Style = []
  OldCreateOrder = False
  Position = poScreenCenter
  OnActivate = FormActivate
  OnClose = FormClose
  OnCreate = FormCreate
  PixelsPerInch = 96
  TextHeight = 14
  object MainPageControl: TPageControl
    Left = 8
    Top = 8
    Width = 625
    Height = 393
    ActivePage = TabSheet3
    TabOrder = 0
    object TabSheet1: TTabSheet
      Caption = 'Introduction && OS Information'
      object GroupBox1: TGroupBox
        Left = 16
        Top = 224
        Width = 537
        Height = 121
        Caption = 'Operating System Details'
        TabOrder = 0
        object OSInfo: TMemo
          Left = 16
          Top = 32
          Width = 505
          Height = 73
          BorderStyle = bsNone
          Color = clBtnFace
          Lines.Strings = (
            'Memo1')
          ReadOnly = True
          TabOrder = 0
        end
      end
      object GroupBox2: TGroupBox
        Left = 16
        Top = 24
        Width = 537
        Height = 193
        Caption = 'About RDA'
        TabOrder = 1
        object Memo1: TMemo
          Left = 16
          Top = 24
          Width = 505
          Height = 153
          Color = clBtnFace
          Lines.Strings = (
            'Raw Disk Access - Concept Application v 1.0'
            ''
            
              'Based on the Raw Disk Access unit for Delphi 7+, which in turn i' +
              's based on '
            
              'the VWIN32 unit file by Geir Wikran, the RDA Concept Application' +
              ' permits '
            
              'direct disk access to the individual clusters on a drive. The dr' +
              'ive can be '
            
              'FAT12, FAT16, FAT32, or NTFS, and RDA automatically adjusts to t' +
              'he '
            'version of Windows being employed.'
            ''
            
              'RDA is Copyright (C) 2004 by Tom Honaker. All Rights Reserved. R' +
              'DA uses '
            
              'portions of the VWIN32 unit file created by Geir Wikran. Both RD' +
              'A and '
            
              'VWIN32 are freely available, provided that the source code is no' +
              't ever '
            
              'distributed for profit. Use in private and commercial applicatio' +
              'ns is permitted. '
            'See the RDA unit file'#39's header for licensing requirements.')
          ReadOnly = True
          ScrollBars = ssVertical
          TabOrder = 0
        end
      end
    end
    object TabSheet3: TTabSheet
      Caption = 'Disk Clusters'
      ImageIndex = 2
      object Label1: TLabel
        Left = 8
        Top = 11
        Width = 131
        Height = 14
        Caption = 'Logical Drive................'
        Transparent = True
      end
      object ClusterPageControl: TPageControl
        Left = 0
        Top = 48
        Width = 617
        Height = 315
        ActivePage = TabSheet5
        TabOrder = 0
        object TabSheet4: TTabSheet
          Caption = 'Drive Information'
          object DCDriveInfo: TMemo
            Left = 0
            Top = 0
            Width = 609
            Height = 284
            Lines.Strings = (
              'Please choose a drive from the list above.')
            ReadOnly = True
            ScrollBars = ssVertical
            TabOrder = 0
          end
        end
        object TabSheet5: TTabSheet
          Caption = 'Cluster Contents'
          ImageIndex = 1
          object Label2: TLabel
            Left = 8
            Top = 13
            Width = 126
            Height = 14
            Caption = 'Cluster #...................'
            Transparent = True
          end
          object Image1: TImage
            Left = 184
            Top = 252
            Width = 32
            Height = 32
            AutoSize = True
            Picture.Data = {
              055449636F6E0000010002002020100000000000E80200002600000010101000
              00000000280100000E0300002800000020000000400000000100040000000000
              8002000000000000000000000000000000000000000000000000800000800000
              0080800080000000800080008080000080808000C0C0C0000000FF0000FF0000
              00FFFF00FF000000FF00FF00FFFF0000FFFFFF00000000000000000000077000
              0000000000000000000000000077700000000000000000000000000000077000
              0000000000000000000000000F077000000000000000000000000000FF077000
              00000000000000000000070FFF07700000000000000000000077770FFF077777
              00000000000000007770008FFF07777777000000000000070008FFFFFF800077
              77700000000000008FFFFFFFFFFFF800777700000000008FFFFFFFFFFFFFFFF8
              0777700000000FFFFFFFFFFFFFFFFFFFF07777000000FFFFFFFFFFFFFFFFFFFF
              FF077770007FFFFFFFFCCCCCCCCCFFFFFFF07770078FFFFFFFFFFCCCCCFFFFFF
              FFF8077707FFFFFFFFFFFCCCCCFFFFFFFFFF077778FFFFFFFFFFFCCCCCFFFFFF
              FFFF80777FFFFFFFFFFFFCCCCCFFFFFFFFFFF0777FFFFFFFFFFFFCCCCCFFFFFF
              FFFFF0777FFFFFFFFFFFFCCCCCFFFFFFFFFFF0777FFFFFFFFFFFFCCCCCFFFFFF
              FFFFF0777FFFFFFFFFFCCCCCCCFFFFFFFFFFF07078FFFFFFFFFFFFFFFFFFFFFF
              FFFF807007FFFFFFFFFFFFFFFFFFFFFFFFFF0700078FFFFFFFFF8CCCC8FFFFFF
              FFF80000007FFFFFFFFFCCCCCCFFFFFFFFF000000007FFFFFFFFCCCCCCFFFFFF
              FF00000000007FFFFFFF8CCCC8FFFFFFF00000000000078FFFFFFFFFFFFFFFF8
              70000000000000778FFFFFFFFFFFF87700000000000000007778FFFFFF877700
              0000000000000000000777777770000000000000FFFFE7FFFFFFC7FFFFFF87FF
              FFFF07FFFFFE07FFFFF807FFFFC000FFFF00003FFE00001FFC00000FF8000007
              F0000003E0000001C00000018000000080000000000000000000000000000000
              000000000000000000000001000000018000000380000007C000000FE000001F
              F000003FF800007FFC0000FFFF0003FFFFE01FFF280000001000000020000000
              0100040000000000C00000000000000000000000000000000000000000000000
              00008000008000000080800080000000800080008080000080808000C0C0C000
              0000FF0000FF000000FFFF00FF000000FF00FF00FFFF0000FFFFFF0000000000
              00070000000000070F07000000000700FF0700000000008FFF07700000008FFF
              FF0077000078FFFFFFF8077007FFFFFFFFFFF07007FFFFCCCCFFF0777FFFFFFC
              CFFFFF077FFFFFFCCFFFFF077FFFFFCCCFFFFF077FFFFFFFFFFFFF0007FFFFFC
              CFFFF000078FFFF88FFFF00000778FFFFFF770000000777777700000FF8F0000
              FE0F0000F80F0000F0070000E0030000C0010000800100008000000000000000
              0000000000000000000100008003000080030000C0070000F01F0000}
            Stretch = True
          end
          object Label3: TLabel
            Left = 223
            Top = 254
            Width = 201
            Height = 33
            AutoSize = False
            Caption = 'Changing the cluster without saving discards any edits made.'
            Transparent = True
            WordWrap = True
          end
          object DCClusterContents: TMPHexEditor
            Left = 0
            Top = 41
            Width = 609
            Height = 208
            Cursor = crIBeam
            Font.Charset = DEFAULT_CHARSET
            Font.Color = clWindowText
            Font.Height = -9
            Font.Name = 'Tahoma'
            Font.Style = []
            TabOrder = 0
            OnKeyUp = DCClusterContentsKeyUp
            BytesPerRow = 16
            BytesPerColumn = 1
            Translation = tkAsIs
            OffsetFormat = '-!10:0x|'
            CaretKind = ckBottom
            Colors.Background = clWindow
            Colors.ChangedBackground = 11075583
            Colors.ChangedText = clMaroon
            Colors.CursorFrame = clNavy
            Colors.Offset = clBlack
            Colors.OddColumn = clBlue
            Colors.EvenColumn = clNavy
            Colors.CurrentOffsetBackground = clBtnShadow
            Colors.OffsetBackGround = clBtnFace
            Colors.CurrentOffset = clBtnHighlight
            Colors.Grid = clBtnFace
            Colors.NonFocusCursorFrame = clAqua
            FocusFrame = True
            DrawGridLines = True
            GutterWidth = 35
            ShowRuler = True
            SeparateBlocksInCharField = False
          end
          object SaveClusterButton: TButton
            Left = 432
            Top = 256
            Width = 171
            Height = 25
            Caption = 'Save Cluster to Disk...'
            Enabled = False
            TabOrder = 1
            OnClick = SaveClusterButtonClick
          end
          object DCCluster: TSpinEdit
            Left = 112
            Top = 8
            Width = 121
            Height = 23
            EditorEnabled = False
            Enabled = False
            MaxValue = 0
            MinValue = 0
            TabOrder = 2
            Value = 0
            OnChange = DCClusterChange
          end
          object DCScroll: TScrollBar
            Left = 240
            Top = 11
            Width = 297
            Height = 16
            LargeChange = 1024
            PageSize = 0
            TabOrder = 3
            OnChange = DCScrollChange
          end
          object ReadFailedPanel: TPanel
            Left = 96
            Top = 128
            Width = 401
            Height = 41
            BevelInner = bvLowered
            Caption = 'Could not read the selected cluster.'
            TabOrder = 4
            Visible = False
          end
        end
      end
      object DCDrive: TDriveComboBox
        Left = 112
        Top = 8
        Width = 313
        Height = 20
        TabOrder = 1
        OnChange = DCDriveChange
      end
    end
  end
  object RawDiskAccessComponent: TRawDiskAccessComponent
    Left = 368
  end
end
